import java.util.ArrayList;
import java.util.Scanner;

public class G {
    static boolean[] used;
    static ArrayList<ArrayList<Integer>> g;

    public static int[] dfs(int v) {
        int path1 = 0;
        int path2 = 0;
        int max = 0;
        used[v] = true;
        for (int i = 0; i < g.get(v).size(); i++) {
            int u = g.get(v).get(i);
            if (!used[u]) {
                int[] x = dfs(u);
                int maxx1 = x[0];
                if (maxx1 >= path2) {
                    int tmp = Math.min(path1, maxx1 + 1);
                    path1 = Math.max(path1, maxx1 + 1);
                    path2 = tmp;
                }
                max = Math.max(path1 + path2, x[1]);
            }
        }
        int[] ans = {path1, max};
        return ans;
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        int m = sc.nextInt();

        used = new boolean[n];
        g = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            g.add(new ArrayList<>());
            used[i] = false;
        }
        for (int i = 0; i < n - 1; i++) {
            int tmp1 = sc.nextInt() - 1;
            g.get(i + 1).add(tmp1);
            g.get(tmp1).add(i + 1);
        }
        int[] ans = dfs(0);
        System.out.println(ans[1] + 1);
    }

}
